;=====================================================
;MAIN ATYPEX.DLL SOURCE CODE FILE
;=====================================================
ATX_VERSION		equ	'1.36'
NUM_NEWACTIONTYPES	equ	9

;=================================================================
format PE GUI 4.0 DLL at 1500000h
entry DllEntryPoint
;=================================================================

include '%fasminc%\WIN32A.INC'	;must have FASM environment variable set properly for this
include 'Data\basedata.inc'
include 'Data\constants.inc'
include 'Data\ddraw.inc'
include 'Data\macros.inc'
include 'Data\strucs.inc'

;=================================================================
section '.code' code readable executable
;=================================================================

DllEntryPoint:			;initializes DLL for specific EXE
	mov eax,[esp+8]
	cmp eax,DLL_PROCESS_ATTACH
	    jz LoadDLLCode
	cmp eax,DLL_PROCESS_DETACH
	    jz FREE_MEM_1
	mov eax,TRUE
	ret 12
;-----------------------------------
	FREE_MEM_1:
;free possibly loaded buffers and delete temporary files
	LOCALRELEASE [currentbitmap]
	LOCALRELEASE [CAnimal_BUF]
	LOCALRELEASE [CAnimal_Names_INDEX]
	LOCALRELEASE [CAnimal_Names_BUF]
	LOCALRELEASE [CAnimal_Initial_Info]
	LOCALRELEASE [CAnimal_JUMP_Info_BUF]
	LOCALRELEASE [NewDinoVocalsBuffer]

	push esi
	push edi
		mov edi,[MapsPathSize]
		add edi,DDF_FN_Buffer
		mov esi,MAINSCREEN_TEMP_FILE_NAMEONLY
		call TransferString
	invoke DeleteFile,DDF_FN_Buffer

		mov edi,[MapsPathSize]
		add edi,DDF_FN_Buffer
		mov esi,RENDER_TEMP_FILE_NAMEONLY
		call TransferString
	invoke DeleteFile,DDF_FN_Buffer
	pop edi
	pop esi

	call ReleaseAllAVIBuffersDLLExit

	mov eax,TRUE
	ret 12
;-----------------------------------
include 'INIT_RT\_INIT_RT_PROCS.inc'

LoadDLLCode:
	mov eax,[esp+4]
	mov [DLLHandle],eax

	call CreateLogFile

	push esi
	push edi
	push ebp
	push ebx

	xor ebp,ebp		;ebp -> used for error logging

include 'INIT_RT\_DETECT_EXE.inc'
include 'INIT_RT\_MAIN_SET.inc'

ExitInit:

       pop ebx
       pop ebp
       pop edi
       pop esi
       xor eax,eax
       test [DLLLoadSuccessBool],1
	    setz al		;return load DLL success/error
       ret 12

;=================================================================

;Main ActionType functions
include 'ActionTypes\_INAT.inc'
include 'ActionTypes\AT100_MXTTimed.inc'
include 'ActionTypes\AT101_MXTSet.inc'
include 'ActionTypes\AT102_LoadNewMap.inc'
include 'ActionTypes\AT103_ReloadGun.inc'
include 'ActionTypes\AT104_PlayerHealth.inc'
include 'ActionTypes\AT105_PlaySMKVideo.inc'
include 'ActionTypes\AT106_LoadNewHint.inc'
include 'ActionTypes\AT107_ATXDRVStart.inc'
include 'ActionTypes\AT108_ATXDRVStop.inc'

;Explicitly enabled hacks/cheats/other
include 'RT\_MAIN_CHEATS.inc'
include 'RT\_RT_PROCS.inc'
include 'RT\ACTJUMPNEW.inc'
include 'RT\ATXDRV.inc'
include 'RT\BACK_BUFFER_DRAW_MAIN.inc'
include 'RT\CANIMAL_INIT.inc'
include 'RT\DINOVOCALPROCNEW.inc'
include 'RT\DISPLAY_CANIMAL.inc'
include 'RT\DISPLAY_DRAWDIST.inc'
include 'RT\DISPLAY_FPS.inc'
include 'RT\DISPLAY_MAP.inc'
include 'RT\DISPLAY_NEWKEYSSTATE.inc'
include 'RT\DISPLAY_TIME.inc'
include 'RT\DISPLAY_TEMP.inc'
include 'RT\DISPLAY_TEST.inc'
include 'RT\DDRAWMAIN.inc'
include 'RT\DRAWDISTRT.inc'
include 'RT\ENDLEVELLOAD.inc'
include 'RT\ERRORCOUNT.inc'
include 'RT\FLYMODE.inc'
include 'RT\HINTMOD.inc'
include 'RT\KEYHANDLER.inc'
include 'RT\LOADINITIALBITMAP.inc'
include 'RT\MENU_MOD.inc'
include 'RT\ON_ACTBITE.inc'
include 'RT\RANDOM_DINOS.inc'
include 'RT\RECORD.inc'
include 'RT\SAVEMAPSTATE.inc'
include 'RT\TRESSTRDBG.inc'

;=================================================================
section '.data' data readable writeable
;=================================================================

include 'Data\exedata.inc'
include 'Data\generaldata.inc'
include 'Data\inidata.inc'
include 'Data\initrtdata.inc'

;=================================================================
section '.idata' import data readable writeable
;=================================================================

  library kernel,"KERNEL32.DLL",\
	  user32,"USER32.DLL",\
	  gdi,"GDI32.DLL",\
	  msvcrt,"MSVCRT.DLL",\
	  winmm,"WINMM.DLL"

  import kernel,\
	 CloseHandle,"CloseHandle",\
	 CopyFile,"CopyFileA",\
	 CreateFile,"CreateFileA",\
	 CreateFileMapping,'CreateFileMappingA',\
	 DeleteFile,'DeleteFileA',\
	 ExitProcess,"ExitProcess",\
	 FindClose,"FindClose",\
	 FindFirstFile,"FindFirstFileA",\
	 FlushInstructionCache,"FlushInstructionCache",\
	 FreeLibrary,"FreeLibrary",\
	 GetCurrentProcessId,"GetCurrentProcessId",\
	 GetFileSize,"GetFileSize",\
	 GetLastError,"GetLastError",\
	 GetModuleFileName,"GetModuleFileNameA",\
	 GetPrivateProfileInt,"GetPrivateProfileIntA",\
	 GetPrivateProfileSection,"GetPrivateProfileSectionA",\
	 GetPrivateProfileSectionNames,"GetPrivateProfileSectionNamesA",\
	 GetPrivateProfileString,"GetPrivateProfileStringA",\
	 GetProcAddress,"GetProcAddress",\
	 GetSystemInfo,"GetSystemInfo",\
	 GetTickCount,"GetTickCount",\
	 IsBadReadPtr,"IsBadReadPtr",\
	 IsBadWritePtr,"IsBadWritePtr",\
	 LoadLibrary,"LoadLibraryA",\
	 LocalAlloc,"LocalAlloc",\
	 LocalFree,"LocalFree",\
	 LocalReAlloc,"LocalReAlloc",\
	 LocalSize,"LocalSize",\
	 MapViewOfFile,'MapViewOfFile',\
	 OpenProcess,"OpenProcess",\
	 ReadFile,"ReadFile",\
	 SetEndOfFile,"SetEndOfFile",\
	 SetFileAttributes,"SetFileAttributesA",\
	 SetFilePointer,"SetFilePointer",\
	 UnmapViewOfFile,"UnmapViewOfFile",\
	 VirtualAlloc,'VirtualAlloc',\
	 VirtualFree,'VirtualFree',\
	 VirtualProtectEx,"VirtualProtectEx",\
	 WriteFile,"WriteFile",\
	 WritePrivateProfileString,"WritePrivateProfileStringA",\
	 WriteProcessMemory,"WriteProcessMemory"

  import user32,\
	 DestroyWindow,"DestroyWindow",\
	 FindWindow,"FindWindowA",\
	 CloseWindow,"CloseWindow",\
	 DrawText,"DrawTextA",\
	 GetActiveWindow,"GetActiveWindow",\
	 GetAsyncKeyState,"GetAsyncKeyState",\
	 GetDC,"GetDC",\
	 GetDesktopWindow,"GetDesktopWindow",\
	 KillTimer,"KillTimer",\
	 LoadBitmap,"LoadBitmapA",\
	 LoadString,"LoadStringA",\
	 MessageBox,"MessageBoxA",\
	 ReleaseDC,"ReleaseDC",\
	 SendMessage,"SendMessageA",\
	 SetFocus,"SetFocus",\
	 SetForegroundWindow,"SetForegroundWindow",\
	 SetTimer,"SetTimer",\
	 ShowCursor,"ShowCursor",\
	 ShowWindow,"ShowWindow",\
	 UpdateWindow,"UpdateWindow",\
	 VkKeyScan,"VkKeyScanA",\
	 wsprintf,"wsprintfA"

  import gdi,\
	 BitBlt,"BitBlt",\
	 CreateCompatibleDC,"CreateCompatibleDC",\
	 CreateDIBSection,"CreateDIBSection",\
	 DeleteDC,"DeleteDC",\
	 DeleteObject,"DeleteObject",\
	 SelectObject,"SelectObject",\
	 SetDIBitsToDevice,"SetDIBitsToDevice",\
	 SetPixelV,"SetPixelV",\
	 SetStretchBltMode,"SetStretchBltMode",\
	 SetTextColor,"SetTextColor",\
	 StretchBlt,"StretchBlt",\
	 TextOut,"TextOutA"

  import msvcrt,\
	 rand,"rand",\
	 sprintf,"sprintf",\
	 srand,"srand",\
	 sscanf,"sscanf",\
	 time,"time",\
	 YAPAXI,"??2@YAPAXI@Z"

  import winmm,\
	 mciSendString,"mciSendStringA"

;=================================================================
section '.edata' export data readable
;=================================================================
	export 'ATYPEX.DLL',\
		INAT,'INAT'	;not used - included for compatibility only

;=================================================================
section '.rsrc' resource data readable
;=================================================================

	directory RT_BITMAP,bmps,\
		  RT_VERSION,versions

	resource bmps,\
		 100,LANG_NEUTRAL,blinkerbmp

	resource versions,\
	   1,LANG_NEUTRAL,version

	bitmap blinkerbmp,"BLINKER.bmp"

	versioninfo version,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,\
				LANG_ENGLISH+SUBLANG_DEFAULT,0,\
	  'FileDescription','Part of ATX Trespasser modification',\
	  'LegalCopyright','Free, open source.',\
	  'FileVersion',ATX_VERSION,\
	  'ProductVersion',ATX_VERSION,\
	  'OriginalFilename','ATYPEX.DLL'

;=================================================================
section '.reloc' fixups data discardable readable
;=================================================================
