;=================================================================
;MENU MODIFICATION/INTERCEPTION CODE AND GAME DIFFICULTY MOD
;=================================================================

SLIDER_METHOD_INTERCEPT_ADDR	dd	SLIDER_METHOD_INTERCEPT
;=================================================================
SLIDER_METHOD_INTERCEPT:	;called for EVERY slider in every menu
;=================================================================
push esi
mov esi,ecx			   ;save object

	push DWORD [esp+10h]	   ;pass parameters to true method properly
	push DWORD [esp+10h]
	push DWORD [esp+10h]
	call [SLIDER_METHOD_TRUE]  ;call function that calculates new slider value

mov edx,[esi+0Ch]
push eax

;GAME DIFFICULTY SLIDER CHECK
	cmp edx,SLIDER_GAME_DIFFICULY_ID
	    jz GAME_DIFFICULTY_SLIDER_SET

;DRAW DISTANCE SLIDER CHECK
	cmp edx,SLIDER_DRAW_DISTANCE_ID
	    jz DRAW_DISTANCE_SLIDER_SET

pop eax
pop esi
ret 0Ch

;----------------
GAME_DIFFICULTY_SLIDER_SET:
;----------------
	xor edx,edx
	mov dl,[esi+30h]	  ;retrieve new slider value from slider instance
	mov [GameDifficultyValue],edx
	    sub esp,100
	    lea ecx,[esp]
	invoke wsprintf,ecx,_unint,edx
	       add esp,12
	       lea ecx,[esp]
	invoke WritePrivateProfileString,section_general,key_gamediff,ecx,ATXconfiginiFN
	    add esp,100
pop eax
pop esi
ret 0Ch

;----------------
DRAW_DISTANCE_SLIDER_SET:
;----------------
	fild DWORD [esi+30h]
	sub esp,4
	fadd [float_15]
	fstp DWORD [esp]
	call ModifyDrawDistanceMENU
pop eax
pop esi
ret 0Ch

BUTTON_METHOD_INTERCEPT_ADDR	dd	BUTTON_METHOD_INTERCEPT
;=================================================================
BUTTON_METHOD_INTERCEPT:	;ALSO CHECKS FOR LEVEL RESTART
;=================================================================
;At entry, ecx is button instance (object). Member DWORD [ecx+4] is an object
;which describes the target function. Target function VTable is compared
;to a VTable such as the "Restart Level" VTable (often, the VTable is the same
;for all objects on a same DDF file or page). Button instance can then be
;tested for YES/NO/other buttons via ID at [ecx+0Ch].

	mov eax,[ecx+4]
	test eax,eax
	     jz NO_TOGGLE_RESTART_BOOL_ALL

;test for "Restart Level" YES button
	mov edx,[EXIT_RESTART_VTABLE]
	cmp [eax],edx
	    jnz NO_TOGGLE_RESTART_BOOL
	cmp DWORD [ecx+0Ch],1000	;YES function = 1000, NO = 1001
	    jnz NO_TOGGLE_RESTART_BOOL
	or [Restart_Exit_Level_BOOL],1
	NO_TOGGLE_RESTART_BOOL:

;test for NEWGAME button
	mov edx,[NEWGAME_VTABLE]
	cmp [eax],edx
	    jnz NO_TOGGLE_RESTART_NEWGAME_BOOL
	cmp DWORD [ecx+0Ch],1000
	    jnz NO_TOGGLE_RESTART_NEWGAME_BOOL
	or [Restart_Exit_Level_BOOL],1
	NO_TOGGLE_RESTART_NEWGAME_BOOL:

;test for QUICKLOAD OK button
	mov edx,[QUICKLOADOK_VTABLE]
	cmp [eax],edx
	    jnz NO_TOGGLE_RESTART_QLOK_BOOL
	cmp DWORD [ecx+0Ch],1001
	    jnz NO_TOGGLE_RESTART_QLOK_BOOL
	or [Restart_Exit_Level_BOOL],1
	NO_TOGGLE_RESTART_QLOK_BOOL:

	NO_TOGGLE_RESTART_BOOL_ALL:

	push DWORD [esp+0Ch]	   ;pass parameters to true method properly
	push DWORD [esp+0Ch]
	push DWORD [esp+0Ch]
	call [BUTTON_METHOD_TRUE]
ret 0Ch

CHECKBOX_METHOD_INTERCEPT_ADDR	  dd	  CHECKBOX_METHOD_INTERCEPT
;=================================================================
CHECKBOX_METHOD_INTERCEPT:	  ;(not specifically or currently used - hotspots used instead)
;=================================================================
	jmp [CHECKBOX_METHOD_TRUE]

;during function
;member BYTE [esi+24h] = 3 if un-check is being done
;member BYTE [esi+24h] = 1 if check is being done
;after function (location unknown)
;member BYTE [esi+24h] and BYTE [esi+28h] = 0 if un-checked
;member BYTE [esi+24h] and BYTE [esi+28h] = 2 if checked

HOTSPOT_METHOD_INTERCEPT_ADDR	 dd	 HOTSPOT_METHOD_INTERCEPT
;=================================================================
HOTSPOT_METHOD_INTERCEPT:
;=================================================================
mov eax,[ecx+0Ch]
push ecx

	cmp eax,HOTSPOT_MATRIX_ID
	    jz Matrix_Hotspot_Clicked

	cmp eax,HOTSPOT_JUMP_DINOS_ID
	    jz Jump_Dinos_Hotspot_Clicked

	cmp eax,HOTSPOT_RANDOM_DINOS_ID
	    jz Random_Dinos_Hotspot_Clicked

EXIT_HOTSPOT_METHOD_INTERCEPT:
pop ecx
	push DWORD [esp+0Ch]	   ;pass parameters to true method properly
	push DWORD [esp+0Ch]
	push DWORD [esp+0Ch]
	call [HOTSPOT_METHOD_TRUE]
ret 0Ch

Matrix_Hotspot_Clicked:
   DOHOTSPOTCLICK UseMXTBITE,section_mxt,key_mxtb,CHECKBOX_MATRIX_OBJ

Jump_Dinos_Hotspot_Clicked:
   DOHOTSPOTCLICK UseDisableActJumpNew,section_actjumpnew,key_nojump,CHECKBOX_JUMP_DINOS_OBJ

Random_Dinos_Hotspot_Clicked:
   DOHOTSPOTCLICK UseRandomDinoLocations,section_general,key_rand,CHECKBOX_RANDOM_DINOS_OBJ

;=================================================================
ENDOBJECTLOAD_INTERCEPT:	;esi=object -> FOR ALL VISUAL OBJECTS
;=================================================================
pop edx 	      ;return address
		      ;must not modify eax
push esi	      ;REPLACED CODE
mov ecx,edi	      ;REPLACED CODE
push edx

	cmp DWORD [esi+0Ch],CHECKBOX_MATRIX_ID
	    jnz NOT_CHECKBOX_MATRIX_ID_2
	mov edx,[UseMXTBITE]
	mov [CHECKBOX_MATRIX_OBJ],esi
	call CheckboxValueGetProc
	NOT_CHECKBOX_MATRIX_ID_2:

	cmp DWORD [esi+0Ch],CHECKBOX_JUMP_DINOS_ID
	    jnz NOT_CHECKBOX_JUMP_DINOSID_2
	mov edx,[UseDisableActJumpNew]
	mov [CHECKBOX_JUMP_DINOS_OBJ],esi
	call CheckboxValueGetProc
	NOT_CHECKBOX_JUMP_DINOSID_2:

	cmp DWORD [esi+0Ch],CHECKBOX_RANDOM_DINOS_ID
	    jnz NOT_CHECKBOX_RANDOM_DINOSID_2
	mov edx,[UseRandomDinoLocations]
	mov [CHECKBOX_RANDOM_DINOS_OBJ],esi
	call CheckboxValueGetProc
	NOT_CHECKBOX_RANDOM_DINOSID_2:

jmp DWORD [eax+70h]   ;REPLACED CODE - modified - will return to exe upon RET

CheckboxValueGetProc:
	add edx,edx	     ;if value 0, will be 0; if value 1, will be 2
	mov [esi+24h],dl
	mov [esi+28h],dl
ret

;=================================================================
MAINSCREEN_INTERCEPT:	   ;eax=filename (must be passed to CreateFileA)
;=================================================================
;CALLED FOR MORE THAN ONE SCREENS (MAINSCREEN.ddf, RENDER.ddf)

	pop edx
	mov [MAINSCREEN_DDF_RET_ADDR],edx	;save return address

repz movsb	   ;REPLACED CODE
push eax	   ;REPLACED CODE (filename for CreateFile)

	cmp [UseNewMenuItems],2
	    jz NoTestForMainscreenDDF
	COMPSTR [edi-15],[MAINSCREEN_TEMP_FILE_NAMEONLY]
	      test eax,eax
		   jnz MAINSCREEN_DDF_FOUND
	NoTestForMainscreenDDF:

	COMPSTR [edi-11],[RENDER_TEMP_FILE_NAMEONLY]
	      test eax,eax
		   jnz RENDER_DDF_FOUND

EXIT_DDF_INTERCEPT:
call ebp	   ;REPLACED CODE (call [CreateFileA])
mov esi,eax	   ;REPLACED CODE
jmp [MAINSCREEN_DDF_RET_ADDR]

MAINSCREEN_DDF_FOUND:
	push esi
	push edi
	mov esi,MAINSCREEN_TEMP_FILE_NAMEONLY
	mov edi,[MapsPathSize]
	add edi,DDF_FN_Buffer
	call TransferString
	pop edi
	pop esi

	       mov eax,[esp]
	invoke CopyFile,eax,DDF_FN_Buffer,FALSE
	       test eax,eax
		    jz EXIT_DDF_INTERCEPT

	mov eax,[GameDifficultyValue]
	cmp eax,5
	    jb GameDifficultyValueValid2
	    mov eax,2
	    mov [GameDifficultyValue],eax
	GameDifficultyValueValid2:
	add al,30h			;convert to ASCII
	mov BYTE [Default_GSPD_Slider_Unit_Value],al

	mov edx,NEW_MENU_DATA_BUFFER_END
	cmp [EXEID],'DEMO'
	    jnz ShowEnableRandomDinosCheckbox
	    mov edx,NEW_MENU_DATA_BUFFER_END_DEMO
	ShowEnableRandomDinosCheckbox:
	sub edx,NEW_MENU_DATA_BUFFER

	stdcall WRITE_DDF_NEW,DDF_FN_Buffer,NEW_MENU_DATA_BUFFER,edx
		test eax,eax
		     jz EXIT_DDF_INTERCEPT

	mov DWORD [esp],DDF_FN_Buffer	 ;replace DDF filename used by EXE in CreateFileA
	jmp EXIT_DDF_INTERCEPT

RENDER_DDF_FOUND:
	push esi
	push edi
	mov esi,RENDER_TEMP_FILE_NAMEONLY
	mov edi,[MapsPathSize]
	add edi,DDF_FN_Buffer
	call TransferString
	pop edi
	pop esi

	       mov eax,[esp]
	invoke CopyFile,eax,DDF_FN_Buffer,FALSE
	       test eax,eax
		    jz EXIT_DDF_INTERCEPT

	mov eax,[DrawDistanceVarADDR]	;get current Draw Dist value from EXE for slider
	push DWORD [eax]
	fld DWORD [esp]
	fsub [float_15]
	fistp DWORD [esp]
	pop eax
	cmp eax,0
	    jnl DrawDist_Positive
	    xor eax,eax
	DrawDist_Positive:
	cmp eax,300
	    jna DrawDist_Below300
	    mov eax,300
	DrawDist_Below300:
	invoke wsprintf,Default_DRAWDIST_Slider_Unit_Value,_unint,eax
	       add esp,12

	mov eax,Default_DRAWDIST_Slider_Unit_Value
	FINDSTRINGEND eax
	mov BYTE [eax],20h	   ;remove null-terminator


	stdcall WRITE_DDF_NEW,DDF_FN_Buffer,\
		 NEW_RENDER_DATA_BUFFER,(NEW_RENDER_DATA_BUFFER_END-NEW_RENDER_DATA_BUFFER)
		test eax,eax
		     jz EXIT_DDF_INTERCEPT

	mov DWORD [esp],DDF_FN_Buffer
	jmp EXIT_DDF_INTERCEPT

;=================================================================
WRITE_DDF_NEW:	   ;returns FALSE if error
;=================================================================
;[ebp+8] = name of file to modify
;[ebp+12] = buffer (to write from)
;[ebp+16] = size of buffer
push ebp
mov ebp,esp
sub esp,12
mov DWORD [ebp-4],0
mov DWORD [ebp-8],0
mov DWORD [ebp-12],FALSE

	invoke SetFileAttributes,[ebp+8],FILE_ATTRIBUTE_NORMAL
	       test eax,eax
		    jz ERROR_DDF_NEW

	invoke CreateFile,[ebp+8],GENERIC_WRITE,0,0,\
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
	       cmp eax,-1
		    jz ERROR_DDF_NEW
	       mov [ebp-4],eax

	invoke SetFilePointer,[ebp-4],0,0,FILE_END
	       cmp eax,-1
		    jz ERROR_DDF_NEW

	       lea ecx,[ebp-8]
	invoke WriteFile,[ebp-4],[ebp+12],[ebp+16],ecx,0
	       test eax,eax
	       mov ecx,[ebp-8]
		    jz ERROR_DDF_NEW
	       cmp ecx,[ebp+16]
		    jnz ERROR_DDF_NEW

	mov DWORD [ebp-12],TRUE

ERROR_DDF_NEW:
	CLOSEHANDLE DWORD [ebp-4]
	mov eax,[ebp-12]
mov esp,ebp
pop ebp
ret 12


;=================================================================
SetGameDifficulty:
;=================================================================

mov esi,[CAnimal_BUF]
sub esi,4
    jb NoModCAnimalInst_GAMEDIFF
mov ebx,[CAnimal_BUF_SIZE]
cmp ebx,4
    jb NoModCAnimalInst_GAMEDIFF
add ebx,esi

	mov edx,[GameDifficultyValue]
	cmp edx,5
	    jb GameDifficultyValueValid
	    mov edx,2
	GameDifficultyValueValid:
	shl edx,2			 ;*4

	CAnimalModLoop_GAMEDIFF:
	add esi,4
	mov edi,[esi]
	call DoMods_CAnimal_GAMEDIFF
	cmp esi,ebx
	    jb CAnimalModLoop_GAMEDIFF
NoModCAnimalInst_GAMEDIFF:

	mov eax,[PLAYER_OBJ_INVUL_ADDR]
	mov edi,[eax]
;Player HitPoints multiplier
	fld DWORD [edi+50h]
	fmul DWORD [GAME_DIFFICULTY_TABLE+20+edx]
	fstp DWORD [edi+50h]
;Player MaxHitPoints multiplier
	fld DWORD [edi+54h]
	fmul DWORD [GAME_DIFFICULTY_TABLE+20+edx]
	fstp DWORD [edi+54h]

ret

DoMods_CAnimal_GAMEDIFF:
;CAnimal HitPoints multiplier
	fld DWORD [edi+50h]
	fmul DWORD [GAME_DIFFICULTY_TABLE+0+edx]
	fstp DWORD [edi+50h]
;CAnimal MaxHitPoints multiplier
	fld DWORD [edi+54h]
	fmul DWORD [GAME_DIFFICULTY_TABLE+0+edx]
	fstp DWORD [edi+54h]
ret
;================================================================
