;=====================================================
;VARIOUS PROCEDURES
;=====================================================

;============================================================
GetInstanceFromString:	 ;eax = instance's name, returns in eax (null if error)
;============================================================
;THIS FUNCTION IS COPIED ALMOST ENTIRELY FROM THE EXECUTABLE.
;IT IS POORLY CODED, BUT MOSTLY UNCHANGED FOR COMPATIBILITY
;WITH MAIN FUNCTION.

push esi
push ecx
push edx

     mov esi,eax
     push 16
     call [YAPAXI]
     add esp,4
     test eax,eax
	  jz GETINST_MEM1_NOTOK
     push [GETINST_ADDR1]
     mov ecx,eax
     call [GETINST_PROC1]
     jmp GETINST_MEM1_OK
	 GETINST_MEM1_NOTOK:
	 xor eax,eax
     GETINST_MEM1_OK:

     push eax
     push 0
     sub esp,8
     mov ecx,esp
     push esi
     call [GETINST_PROC2]
     mov eax,[GETINST_ADDR2]
     mov edx,[eax]
     mov ecx,[edx+4]
     call [GETINST_PROC3]      ;takes 4 parameters (push eax; push 0; sub esp,8)

pop edx
pop ecx
pop esi
ret

;============================================================
GetDDrawObject: 	;returns in eax (should be NULL if none)
;============================================================
push ecx
     mov ecx,[DDRAW_OBJ_BASE]
     mov eax,[ecx+4]
     test eax,eax
	  jnz D3D_DDraw_Object_Found
     mov eax,[ecx]			;(software mode otherwise)
     D3D_DDraw_Object_Found:
pop ecx
ret

;============================================================
CompareStrings: 	;ecx=string1, edx=string2 ; ignores case
;============================================================
			;returns FALSE if not same, edx and ecx point to null-terminators
CompareStringsLoop: ;edi points to dest.'s null-terminator (BYTE [edi] = 0)
     mov al,[ecx]
     mov ah,[edx]	       ;transfer/append string
     CHAR_TOLOWERCASE al
     CHAR_TOLOWERCASE ah
     cmp ah,al
	 jnz StringsNotSame
     test al,al
	  jz StringsSame
     inc ecx
     inc edx
     jmp CompareStringsLoop
StringsSame:
     mov eax,TRUE
ret

StringsNotSame:
     xor eax,eax
ret

;============================================================
TransferString: 	;esi=source, edi=dest., destroyed: esi,edi, al
;============================================================
TransferStringLoop: ;edi points to dest.'s null-terminator (BYTE [edi] = 0)
     mov al,[esi]
     mov [edi],al	      ;transfer/append string
     test al,al
	  jz End_TransferStringLoop
     inc esi
     inc edi
     jmp TransferStringLoop
End_TransferStringLoop:
ret

;============================================================
DisableInGameMvtKeys:
;============================================================
push edx
push eax
     mov edx,[KEY_LIST_ADDR]
     xor eax,eax
     mov [edx+4+(5*8)],eax    ;jump
     mov [edx+4+(10*8)],eax   ;run
     mov [edx+4+(11*8)],eax   ;walk
     mov [edx+4+(12*8)],eax   ;backward
     mov [edx+4+(13*8)],eax   ;left
     mov [edx+4+(14*8)],eax   ;right

pop eax
pop edx
ret

;============================================================
DisableInGameKeys:
;============================================================
push eax
push edx
push esi
     mov edx,[KEY_LIST_ADDR]
     lea esi,[edx+15*8]
     add edx,4
     xor eax,eax

     DisableInGameKeys_Loop:
     mov [edx],eax
     add edx,8
     cmp edx,esi
     jb DisableInGameKeys_Loop

pop esi
pop edx
pop eax
ret

;============================================================
EnableInGameKeys:
;============================================================
push eax
push edx
push esi
     mov edx,[KEY_LIST_ADDR]
     mov esi,DefaultKeyBOOLS
     add edx,4

     EnableInGameKeys_Loop:
     mov eax,[esi]
     mov [edx],eax
     add edx,8
     add esi,4
     cmp esi,DefaultKeyBOOLS_END
     jb EnableInGameKeys_Loop

pop esi
pop edx
pop eax
ret


;============================================================
RANDOMIZE_RANDOM_PROC:
;============================================================
invoke time,0
invoke srand,eax
add esp,8
ret

;============================================================
GetRandomNumber:	;[esp+4] = below or equal to this number and not zero
;============================================================
invoke rand
mov ecx,[esp+4]
test ecx,ecx
     jz GetRandom_DivideByZero
xor edx,edx		;parameter must NOT be null
div ecx 		;(note: I didn't think of this)
mov eax,edx		;remainder
add eax,1
ret 4			;returns number in eax (0 if param was null)

GetRandom_DivideByZero:
xor eax,eax
ret 4

;============================================================
IsLevelSavedGame:	;returns 0 if false, non-zero if true
;============================================================
;NOTE: If a Level Restart was performed before last load,
;      automatically NOT a saved game.
push edi
push ecx
push esi

	or ecx,0FFFFFFFFh
	mov edi,[LEVELNAME_OBJ]
	add edi,20
	xor eax,eax
	repnz scasb

	cmp DWORD [edi-5],'.SCN'
	    jz LevelNotSavedGame
	cmp DWORD [edi-5],'.scn'
	    jz LevelNotSavedGame
	cmp [Restart_Exit_Level_BOOL],1
	    jz LevelNotSavedGame
	or al,1
	LevelNotSavedGame:

pop esi
pop ecx
pop edi
ret

;============================================================
	GetPrivateProfileFloat	dd	GetINIFloat
;============================================================
GetINIFloat:	;returns 32-bit float in eax (null if doesn't exist or if 0)
;============================================================
;[esp+4]=points to section name
;[esp+8]=points to key name
;[esp+12]=default string if none found (pointer)
;[esp+16]=points to INI filename
push ebp
mov ebp,esp
sub esp,104

	lea edx,[ebp-100]
invoke GetPrivateProfileString,[ebp+8],[ebp+12],[ebp+16],edx,\
		100,[ebp+20]

	lea edx,[ebp-104]
	lea eax,[ebp-100]

	cmp BYTE [eax],';'
	    jnz NoEmptyFloatEntry2
	    mov eax,[ebp+16]
	    jmp NoEmptyFloatEntry
	NoEmptyFloatEntry2:

	cmp BYTE [eax],0
	    jnz NoEmptyFloatEntry
	    mov eax,[ebp+16]
	NoEmptyFloatEntry:

invoke sscanf,eax,_float,edx
	add esp,12

	pop eax
mov esp,ebp
pop ebp
ret 16

;============================================================
;Quaternion multiplication (eax=q1, ecx=q2, edx=result)
;============================================================

virtual at eax
	w1	dd	?
	x1	dd	?
	y1	dd	?
	z1	dd	?
end virtual

virtual at ecx
	w2	dd	?
	x2	dd	?
	y2	dd	?
	z2	dd	?
end virtual

QuaternionMul:	      ;eax=q1 , ecx=q2, edx=new quat
;------------- w
	fld [w1]
	fmul [w2]

	fld [x1]
	fmul [x2]
	fsubp st1,st0

	fld [y1]
	fmul [y2]
	fsubp st1,st0

	fld [z1]
	fmul [z2]
	fsubp st1,st0
	fstp DWORD [edx]

;------------- x
	fld [w1]
	fmul [x2]

	fld [x1]
	fmul [w2]
	faddp st1,st0

	fld [y1]
	fmul [z2]
	faddp st1,st0

	fld [z1]
	fmul [y2]
	fsubp st1,st0
	fstp DWORD [edx+4]

;------------- y
	fld [w1]
	fmul [y2]

	fld [x1]
	fmul [z2]
	fsubp st1,st0

	fld [y1]
	fmul [w2]
	faddp st1,st0

	fld [z1]
	fmul [x2]
	faddp st1,st0
	fstp DWORD [edx+8]

;------------- z
	fld [w1]
	fmul [z2]

	fld [x1]
	fmul [y2]
	faddp st1,st0

	fld [y1]
	fmul [x2]
	fsubp st1,st0

	fld [z1]
	fmul [w2]
	faddp st1,st0
	fstp DWORD [edx+12]

ret


;============================================================
ToLocalQuat_AxisX:    ;ecx=pointer to radian angle to rotate by, edx=local_rotation pointer wxyz
;============================================================
				;axis.x = 1.00000 , axis.y=0.0000, axis.z=0.00000
	fld DWORD [ecx]
	fmul [float_0_5]
	fld st0
	fsin
	fst DWORD [edx+4]	;x
	fmul st0,st0

	fxch
	fcos
	fst DWORD [edx] 	;w
	fmul st0,st0
	faddp st1,st0

	fsqrt			;magnitude
	xor eax,eax
	fdivr [float_one]	;1/magnitude
	fld st0

	fmul DWORD [edx]	;normalize w
	      mov [edx+8],eax	;y
	fstp DWORD [edx]
	fmul DWORD [edx+4]	;normalize x
	      mov [edx+12],eax	;z
	fstp DWORD [edx+4]

ret

;============================================================
ToLocalQuat_AxisY:    ;ecx=pointer to radian angle to rotate by, edx=local_rotation pointer wxyz
;============================================================
				;axis.x = 0.00000 , axis.y=1.0000, axis.z=0.00000
	fld DWORD [ecx]
	fmul [float_0_5]
	fld st0
	fsin
	fst DWORD [edx+8]	;y
	fmul st0,st0

	fxch
	fcos
	fst DWORD [edx] 	;w
	fmul st0,st0
	faddp st1,st0

	fsqrt			;magnitude
	xor eax,eax
	fdivr [float_one]	;1/magnitude
	fld st0

	fmul DWORD [edx]	;normalize w
	      mov [edx+4],eax	;x
	fstp DWORD [edx]
	fmul DWORD [edx+8]	;normalize y
	      mov [edx+12],eax	;z
	fstp DWORD [edx+8]

ret

;============================================================
ToLocalQuat_AxisZ:    ;ecx=pointer to radian angle to rotate by, edx=local_rotation pointer wxyz
;============================================================
				;axis.x = 0.00000 , axis.y=0.0000, axis.z=1.00000
	fld DWORD [ecx]
	fmul [float_0_5]
	fld st0
	fsin
	fst DWORD [edx+12]	 ;z
	fmul st0,st0

	fxch
	fcos
	fst DWORD [edx] 	;w
	fmul st0,st0
	faddp st1,st0

	fsqrt			;magnitude
	xor eax,eax
	fdivr [float_one]	;1/magnitude
	fld st0

	fmul DWORD [edx]	;normalize w
	      mov [edx+8],eax	;y
	fstp DWORD [edx]
	fmul DWORD [edx+12]	;normalize z
	      mov [edx+4],eax	;x
	fstp DWORD [edx+12]

ret

;============================================================
QuatToAxisAngle:	;eax = w,x,y,z quat ;ecx = angle+axis (angle in radians, axisx, axisy, axisz)
;============================================================
sub esp,16
	mov edx,[eax]
	mov [esp],edx
	mov edx,[eax+4]
	mov [esp+4],edx
	mov edx,[eax+8]
	mov [esp+8],edx
	mov edx,[eax+12]
	mov [esp+12],edx
	mov eax,esp
	call NormalizeQuat

	fld DWORD [eax] 	;cos
	fmul st0,st0
	fsubr [float_one]
	fsqrt			;sin = sqrt(1.0-cos^2)
	fld st0
	fld DWORD [eax]
	fpatan			;acos = tan_-1 (sin/cos)
	fmul [float_two]	;angle = acos*2
	fstp DWORD [ecx]

	fld st0
	fabs
	fcomp [float_0_0005]	 ;sin now in st0
	push eax
	fstsw ax
	test eax,100h		;sin < 0.0005 ?
	     jz sinnotbelow0_0005
	     fstp st0
	     fld1		;if so, sin = 1.000000
	     sinnotbelow0_0005:
	pop eax

	fdivr [float_one]	;1/sin

	fld DWORD [eax+4]	;x
	fmul st0,st1		;x/sin
	fstp DWORD [ecx+4]	;axisx

	fld DWORD [eax+8]	;y
	fmul st0,st1		;y/sin
	fstp DWORD [ecx+8]	;axisy

	fld DWORD [eax+12]	;z
	fmul st0,st1		;z/sin
	fstp DWORD [ecx+12]	;axisz

	fstp st0

add esp,16
ret

;============================================================
NormalizeQuat:		;eax = quat (w,x,y,z)
;============================================================
	fld DWORD [eax]
	fmul st0,st0
	fld DWORD [eax+4]
	fmul st0,st0
	fld DWORD [eax+8]
	fmul st0,st0
	fld DWORD [eax+12]
	fmul st0,st0
	faddp
	faddp
	faddp
	fsqrt

	fdivr [float_one]

	fld st0
	fmul DWORD [eax]
	fstp DWORD [eax]
	fld st0
	fmul DWORD [eax+4]
	fstp DWORD [eax+4]
	fld st0
	fmul DWORD [eax+8]
	fstp DWORD [eax+8]

	fmul DWORD [eax+12]
	fstp DWORD [eax+12]

ret

;============================================================
FacingToVectorSub:   ;eax = xyz facing values, ecx = xyz position to fsubr from, edx = dest.
;============================================================
		     ;[esp+4] = DWORD float, scalar quantity (distance, push) to use as vector length
		     ;note: ecx = edx is accepted
;converts directional "facing" values to a vector with specified length, and substracts this vector
;from a (x,y,z) location value to get final location/value.

	fld DWORD [eax+8]		  ;z facing value
	fmul [pidivtwo] 		  ;angle w/ z axis
	fld st0 			  ;save
	fsin				  ;z component of Emitter-Target distance
	fmul DWORD [esp+4]		  ;general multiplier (distance)
	fsubr DWORD [ecx+8]		  ;TargetZPosition-EmitterZDistance
	fstp DWORD [edx+8]		  ;=EmitterZPosition

	fcos				  ;Emitter-Target component on X-Y plane
	fabs				  ;should be positive
	fmul DWORD [esp+4]		  ;convert to distance on plane

	fld DWORD [eax] 		  ;x facing angle value
	fmul [pidivtwo] 		  ;convert to radians
	fsin
	fmul st0,st1
	fsubr DWORD [ecx]		  ;Xpos (of target intance)
	fstp DWORD [edx]		  ;Emitter Xpos

	fld DWORD [eax+4]		  ;y facing angle value
	fmul [pidivtwo] 		  ;convert to radians
	fsin
	fmulp
	fsubr DWORD [ecx+4]		  ;Ypos (of target intance)
	fstp DWORD [edx+4]		  ;Emitter Ypos

ret 4

;============================================================
FacingToVectorAdd:   ;eax = xyz facing values, ecx = xyz position to add to, edx = dest.
;============================================================
		     ;[esp+4] = DWORD float, scalar quantity (distance, push) to use as vector length
		     ;note: ecx = edx is accepted
;same as above, but adds

	fld DWORD [eax+8]		  ;z facing value
	fmul [pidivtwo] 		  ;angle w/ z axis
	fld st0 			  ;save
	fsin				  ;z component of Emitter-Target distance
	fmul DWORD [esp+4]		  ;general multiplier (distance)
	fadd DWORD [ecx+8]		  ;TargetZPosition+EmitterZDistance
	fstp DWORD [edx+8]		  ;=EmitterZPosition

	fcos				  ;Emitter-Target component on X-Y plane
	fabs				  ;should be positive
	fmul DWORD [esp+4]		  ;convert to distance on plane

	fld DWORD [eax] 		  ;x facing angle value
	fmul [pidivtwo] 		  ;convert to radians
	fsin
	fmul st0,st1
	fadd DWORD [ecx]		  ;Xpos (of target intance)
	fstp DWORD [edx]		  ;Emitter Xpos

	fld DWORD [eax+4]		  ;y facing angle value
	fmul [pidivtwo] 		  ;convert to radians
	fsin
	fmulp
	fadd DWORD [ecx+4]		  ;Ypos (of target intance)
	fstp DWORD [edx+4]		  ;Emitter Ypos

ret 4

;============================================================
CONVERT_TO_FACING_PROC_2A:     ;[esp+4] = destvar, [esp+8]=param2, source quat=ecx
;============================================================
;
;CONVERT_TO_FACING_PROC:
; - quaternion to convert in ecx (w = c0, x = c4, y = c8, z = cC)
; - param2 put into eax in original function ([eax+00h] = a0, [eax+04h] = a4, [eax+08h] = a8)
; - final values put into destvar (first parameter)
; - original function uses local mem to store data (4 DWORDs at esp)
; - qword constant or var stored in EXE used once (referred to as q); should be 0.500000
;
; -> new function uses edx for param2 and eax for destvar, because destvar must
;    be returned in eax anyway


virtual at ecx
	c0	dd	?
	c4	dd	?
	c8	dd	?
	cC	dd	?
end virtual

virtual at edx
	a0	dd	?
	a4	dd	?
	a8	dd	?
end virtual

	inc [UseTestCTFRATE_Count]

	fld DWORD [c0]
	fmul st0,st0
	mov eax,[CONVERTTOFACING_VAR1]
	fsub qword [eax]	 ;q (var or constant)

	fld [c0]
	fmul [cC]
	fld [c0]
	fmul [c8]
	fld [c4]
	fmul [cC]
	fld [c0]
	fmul [c4]

	fld [c8]
	fmul [cC]		;st2 when full stack

	fld [c4]
	fmul [c8]
	mov edx,[esp+8]
	mov eax,[esp+4]
	fstp DWORD [esp-4]     ;(c4*c8)

;DWORD [destvar+00h] = [eax] = [esp+04h] (originally)
;          = ((c4^2+(c0^2-q))*a0 + (c4*c8-c0*cC)*a4 + (c0*c8+c4*cC)*a8)*2

	fld [c4]
	fmul st0,st0
	fadd st0,st6
	fmul [a0]

	fld DWORD [esp-4]
	fsub st0,st6
	fmul [a4]
	faddp st1,st0

	fld st4
	fadd st0,st4
	fmul [a8]
	faddp st1,st0
	fadd st0,st0
	fstp DWORD [eax]

;DWORD [destvar+04h] = [eax+4] = [esp+08h] (originally)
;          = ((c8^2+(c0^2-q))*a4 + (c8*cC-c0*c4)*a8 + (c0*cC+c4*c8)*a0)*2

	fld [c8]
	fmul st0,st0
	fadd st0,st6
	fmul [a4]

	fld st1
	fsub st0,st3
	fmul [a8]
	faddp st1,st0

	fld DWORD [esp-4]
	fadd st0,st6
	fmul [a0]
	faddp st1,st0
	fadd st0,st0
	fstp DWORD [eax+4]

;DWORD [destvar+08h] = [eax+8] = [esp+0Ch] (originally)
;          = ((cC^2+(c0^2-q))*a8 + (c4*cC-c0*c8)*a0 + (c0*c4+c8*cC)*a4)*2

	faddp st1,st0		;c0*c4+c8*cC
	fmul [a4]
	fxch st2
	fsubp st1,st0		;c4*cC-c0*c8
	fmul [a0]
	faddp st1,st0

	fld [cC]
	fmul st0,st0
	fadd st0,st3
	fmul [a8]

	fxch st2
	fstp st0
	faddp st1,st0
	fadd st0,st0
	fxch st1
	fstp st0
	fstp DWORD [eax+8]


ret 8

CONVERT_TO_FACING_PROC_2A_END:

;============================================================
CONVERT_TO_FACING_PROC_2B:     ;[esp+4] = destvar, [esp+8]=param2, source quat=ecx
;============================================================

;[destvar+00h] = ((c4^2+(c0^2-q))*a0 + (c4*c8-c0*cC)*a4 + (c0*c8+c4*cC)*a8)*2
;[destvar+04h] = ((c8^2+(c0^2-q))*a4 + (c8*cC-c0*c4)*a8 + (c0*cC+c4*c8)*a0)*2
;[destvar+08h] = ((cC^2+(c0^2-q))*a8 + (c4*cC-c0*c8)*a0 + (c0*c4+c8*cC)*a4)*2
;note: in mm0 = var1, var2
;      var1 is low dword of register, var2 is high dword

	inc [UseTestCTFRATE_Count]

	mov edx,[esp+8]
	mov eax,[esp+4]

	sub esp,4
	movq mm0,qword [c0]
	movq mm1,qword [c8]
	pfmul mm0,mm0
	pfmul mm1,mm1
	pswapd mm2,mm0
	movd [esp],mm0
	push DWORD [esp]
	movq mm0,[esp]	 ;mm0 = c0^2,c0^2, mm1 = c8^2,cC^2, mm2 = c4^2,(c0^2)  (all ^2)

	pfadd mm1,mm0
	pfadd mm2,mm0
	pfsub mm1,qword [float_0_5]
	pfsub mm2,qword [float_0_5]
	pfmul mm1,qword [a4]	     ;mm1 = (c8^2+(c0^2-q))*a4,(cC^2+(c0^2-q))*a8
	pfmul mm2,qword [a0]	     ;mm2 = (c4^2+(c0^2-q))*a0

	movq mm5,qword [c0]
	pswapd mm3,mm5
	pfmul mm3,qword [c8]	     ;mm3 = c4*c8,c0*cC
	push [c0]
	push [cC]
	pswapd mm4,qword [c4]
	pfmul mm4,qword [esp]	     ;mm4 = c8*cC,c0*c4
	pfmul mm5,qword [c8]
	pswapd mm5,mm5		     ;mm5 = c4*cC,c0*c8

;pfpnacc mm,mm
;-> mmlow = mmlow-mmhigh, mmhigh = mmlow+mmhigh
	pfpnacc mm3,mm3 	     ;mm3 = c4*c8-c0*cC,c4*c8+c0*cC
	pfpnacc mm4,mm4 	     ;mm4 = c8*cC-c0*c4,c8*cC+c0*c4
	pfpnacc mm5,mm5 	     ;mm5 = c4*cC-c0*c8,c4*cC+c0*c8

	pswapd mm0,qword [a0]
	pswapd mm6,qword [a4]
	pfmul mm3,mm0		     ;mm3 = (c4*c8-c0*cC)*a4,(c4*c8+c0*cC)*a0
	push [a8]
	push [a0]
	pfmul mm4,mm6		     ;mm4 = (c8*cC-c0*c4)*a8,(c8*cC+c0*c4)*a4
	pfmul mm5,qword [esp]	     ;mm5 = (c4*cC-c0*c8)*a0,(c4*cC+c0*c8)*a8

	pfadd mm1,mm4		     ;mm1 = ((c8^2+(c0^2-q))*a4 + (c8*cC-c0*c4)*a8),
				     ;      ((cC^2+(c0^2-q))*a8 + (c8*cC+c0*c4)*a4)
	pswapd mm6,mm1		     ;mm6 = ((cC^2+(c0^2-q))*a8 + (c8*cC+c0*c4)*a4)
	pfadd mm6,mm5		     ;mm6 = ((cC^2+(c0^2-q))*a8 + (c8*cC+c0*c4)*a4 + (c4*cC-c0*c8)*a0)

	pswapd mm5,mm5
	pfadd mm2,mm3		     ;mm2 = (c4^2+(c0^2-q))*a0 + (c4*c8-c0*cC)*a4

	pswapd mm3,mm3
	pfadd mm2,mm5		     ;mm2 = ((c4^2+(c0^2-q))*a0 + (c4*c8-c0*cC)*a4 + (c4*cC+c0*c8)*a8)
	pfadd mm1,mm3		     ;mm1 = ((c8^2+(c0^2-q))*a4 + (c8*cC-c0*c4)*a8 + (c4*c8+c0*cC)*a0)

	pfadd mm2,mm2		     ;each *2
	pfadd mm1,mm1
	pfadd mm6,mm6
	movd [eax],mm2
	movd [eax+4],mm1
	movd [eax+8],mm6

	femms
	add esp,24
ret 8

;[destvar+00h] = ((c4^2+(c0^2-q))*a0 + (c4*c8+(-c0)*cC)*a4 + (c0*c8+c4*cC)*a8)*2
;[destvar+04h] = ((c8^2+(c0^2-q))*a4 + (c8*cC+(-c0)*c4)*a8 + (c0*cC+c4*c8)*a0)*2
;[destvar+08h] = ((cC^2+(c0^2-q))*a8 + (c4*cC+(-c0)*c8)*a0 + (c0*c4+c8*cC)*a4)*2

CONVERT_TO_FACING_PROC_2B_END:


;============================================================
CONVERT_TO_FACING_PROC_010:	 ;[esp+4] = destvar. (eax), [esp+8] = (unused) , ecx = quat
;============================================================
;This is used when the first param points to:
; DWORD 0.000000, DWORD 1.000000, DWORD 0.000000
;This is standard axis data (I believe), used for LOC cheat facing values,
;FLY cheat and others. Parameters are preserved for future implementation
;and compatibility.

;[destvar+00h] = ((c4^2+(c0^2-q))*a0 + (c4*c8-c0*cC)*a4 + (c0*c8+c4*cC)*a8)*2
;[destvar+04h] = ((c8^2+(c0^2-q))*a4 + (c8*cC-c0*c4)*a8 + (c0*cC+c4*c8)*a0)*2
;[destvar+08h] = ((cC^2+(c0^2-q))*a8 + (c4*cC-c0*c8)*a0 + (c0*c4+c8*cC)*a4)*2
;Where a0 = 0.000000, a4 = 1.000000, a8 = 0.000000
;Result (faster!):
;[destvar+00h] = (c4*c8-c0*cC)*2     (X facing value)
;[destvar+04h] = (c8^2+(c0^2-q))*2   (Y facing value)
;[destvar+08h] = (c0*c4+c8*cC)*2     (Z facing value)

	mov eax,[esp+4]
	fld [cC]
	fld [c8]
	fld [c4]
	fld [c0]

	fld st0
	fmul st0,st0	     ;c0^2
	fld st3 	     ;c8
	fmul st0,st0	     ;c8^2
	fxch st1
	fsub [float_0_5]
	fxch st1
	faddp st1,st0
	fadd st0,st0	     ;*2
	fstp DWORD [eax+4]

	fld st1 	     ;c4
	fmul st0,st3	     ;c4*c8
	fld st1 	     ;c0
	fmul st0,st5	     ;c0*cC
	fxch st1
	fsubrp st1,st0	     ;c4*c8-c0*cC
	fadd st0,st0	     ;*2
	fstp DWORD [eax]

	fmulp st1,st0	     ;c0*c4
	fxch st2
	fmulp st1,st0	     ;c8*cC
	fxch st1
	faddp st1,st0	     ;c0*c4+c8*cC
	fadd st0,st0	     ;*2
	fstp DWORD [eax+8]

ret 8








