;========================================================
ATXDRV_MAIN_RT_PROC:
;========================================================
StraightEmitterTargetDistance_ATXDRV	    equ     [float_100]

cmp [IsInGame_BOOL],0
     jz NoATXDRV_MAIN_RT_PROC
cmp [IsInConsole_BOOL],1
     jz NoATXDRV_MAIN_RT_PROC

       invoke GetTickCount
       mov esi,eax

       mov edi,[KEY_LIST_ADDR]
       and [ATXDRV_CURRENT.UseROTonSMVTOnly],1

       ATXDVR_TESTKEY 80,ATXDRV_FORWARD_FAST_PROC,[LTCFrontFast],[ATXDRV_CURRENT.IntervalFrontFast]
       ATXDVR_TESTKEY 88,ATXDRV_FORWARD_SLOW_PROC,[LTCFrontSlow],[ATXDRV_CURRENT.IntervalFrontSlow]
       ATXDVR_TESTKEY 96,ATXDRV_BACKWARD_PROC,[LTCBack],[ATXDRV_CURRENT.IntervalBack]

       cmp [ATXDRV_CURRENT.UseROTonSMVTOnly],1
	   jz No_Straight_Mvt_Keys_Used_ATXDRV

       ATXDVR_TESTKEY 104,ATXDRV_GOLEFT_PROC,[LTCLeft],[ATXDRV_CURRENT.IntervalLeft]
       ATXDVR_TESTKEY 112,ATXDRV_GORIGHT_PROC,[LTCRight],[ATXDRV_CURRENT.IntervalRight]
       ;ATXDVR_TESTKEY 40,ATXDRV_GOUP_PROC,[LTCUp],[ATXDRV_CURRENT.IntervalUp]
       ;ATXDVR_TESTKEY 48,ATXDRV_GODOWN_PROC,[LTCDown],[ATXDRV_CURRENT.IntervalDown]
       No_Straight_Mvt_Keys_Used_ATXDRV:

NoATXDRV_MAIN_RT_PROC:
ret

;========================================================
ATXDRV_FORWARD_FAST_PROC:
;========================================================
	mov eax,[ATXDRV_CURRENT.PushFrontFast]
	mov DWORD [AT10_SIM_OBJECT+38h],eax
	call ATXDRV_STRAIGHT_PROC
ret

;========================================================
ATXDRV_FORWARD_SLOW_PROC:
;========================================================
	mov eax,[ATXDRV_CURRENT.PushFrontSlow]
	mov DWORD [AT10_SIM_OBJECT+38h],eax
	call ATXDRV_STRAIGHT_PROC
ret

;========================================================
ATXDRV_BACKWARD_PROC:
;========================================================
	mov eax,[ATXDRV_CURRENT.PushBack]
	mov DWORD [AT10_SIM_OBJECT+38h],eax
	call ATXDRV_STRAIGHT_PROC
ATXDRV_BACKWARD_PROC_RET_ADDR:
ret

;========================================================
ATXDRV_STRAIGHT_PROC:	       ;set "Push" value in AT10_SIM_OBJECT+38h
;========================================================
push ebp
mov ebp,esp
sub esp,16
push ebx
push esi
push edi

	mov ebx,[ATXDRV_CURRENT.Instance]
	mov edi,AT10_EMITTER_SIM_OBJECT+3Ch
	lea esi,[ebx+3Ch]
	mov ecx,5
	rep movsd			   ;copy rotation values (same for forward push)

	cmp DWORD [ebp+4],ATXDRV_BACKWARD_PROC_RET_ADDR
	    jnz NO_QUAT_NEGATE_A1	   ;backwards? (flip quat 180 degrees if so)
	    mov ecx,pi			   ;turn 180 degrees
	    lea edx,[ebp-16]
	    call ToLocalQuat_AxisZ	   ;around object z axis (not world z axis)
	    lea eax,[ebx+3Ch]
	    lea ecx,[ebp-16]
	    mov edx,AT10_EMITTER_SIM_OBJECT+3Ch
	    call QuaternionMul
	NO_QUAT_NEGATE_A1:

	mov ecx,AT10_EMITTER_SIM_OBJECT+3Ch	;source values (quat)
	push Temp_Fly_Buffer3			;(default/no importance here)
	push Temp_Fly_Buffer2			;param 1 = dest for values (returned in eax)
	call DWORD [CONVERT_TO_FACING_PROC]	;2 params

	mov edx,AT10_EMITTER_SIM_OBJECT+30h
	push StraightEmitterTargetDistance_ATXDRV
	lea ecx,[ebx+30h]
	call FacingToVectorSub			;(eax =facing values)

	mov edx,AT10_EMITTER_SIM_OBJECT
	mov ecx,AT10_SIM_OBJECT
	mov DWORD [edx+4],0

	mov [ecx+04h],DWORD 0
	mov [ecx+18h],ebx			;Target
	or BYTE [ecx+1Ch],1			;Impulse
	mov eax,[ecx]
	mov [ecx+3Ch],edx			;Emitter object
	call DWORD [eax+8]			;AT10 MAIN PROC

pop edi
pop esi
pop ebx
mov esp,ebp
pop ebp
ret

;========================================================
ATXDRV_GOLEFT_PROC:	       ;[esp+4] = current interval -> DO NOT POP
;========================================================
	fild DWORD [esp+4]			 ;calculate angle to rotate w/framerate variations
	sub esp,4
	fmul [RotRadPerMilSecLeft]
	fstp DWORD [esp]
	;push [ATXDRV_CURRENT.RotAngleLeft]
	call ATXDRV_SIDEWAYS_PROC
ret

;========================================================
ATXDRV_GORIGHT_PROC:	       ;[esp+4] = current interval -> DO NOT POP
;========================================================
	fild DWORD [esp+4]			 ;calculate angle to rotate w/framerate variations
	sub esp,4
	fmul [RotRadPerMilSecRight]
	fstp DWORD [esp]
	;push [ATXDRV_CURRENT.RotAngleLeft]
	call ATXDRV_SIDEWAYS_PROC
ret

;========================================================
ATXDRV_SIDEWAYS_PROC:	  ;ecx = pointer to angle (rad.)
;========================================================
;This proc is VERY far from optimal, so it does not use matrices for
;rotation or anything deviant from what has been used in ATX so far (quat mul., facing values).
;Remember, I'm not a 3D programmer, so bear with me.
;What it does:
;Rotates the current instance by a certain angle, around a certain point (on the x-y plane ONLY,
;this plane being relative to the object's current facing values and NOT to the fixed world x-y plane).
;Normally, the game rotates objects around their centers (without location
;modification), so the only way I can emulate rotating around a specifiable
;point (with my knowledge) is to use a series of quat rotations and vector additions.
;Note: The new rotation point can only be shifted along the axis defined by the object's
;original facing values, so it is relatively one-dimensional.
;1. Substract the specified offset from the object's position to get the new point of rotation.
;   (with relative X-Y plane). This is done by using the object's initial facing values to
;   create a vector to substract along the object's current facing value (single-axis only).
;   The rotation point offset defines the length of this vector.
;2. Do rotation of object using quat multiplication.
;3. Use the new rotation values to create a vector (with length defined by rotation point offset)
;   to add to the point of rotation (which gives final location). (note: must make sure to negate vector
;   for main function, or it will substract instread of adding).


push ebp
mov ebp,esp
sub esp,16+32+12	     ;60
push ebx

	mov ebx,[ATXDRV_CURRENT.Instance]

;move object position to point determined by offset
	lea eax,[ebp-60]
	push Temp_Fly_Buffer3			;(default/no importance here)
	lea ecx,[ebx+3Ch]			;source values (quat)
	push eax				;param 1 = dest for values (returned in eax)
	call DWORD [CONVERT_TO_FACING_PROC]	;2 params

	lea ecx,[ebx+30h]
	push [ATXDRV_CURRENT.RotPosOffset]	;vector length (offset)
	lea edx,[ebp-48+00h]
	call FacingToVectorAdd			;eax = facing values

;rotation object around object's relative z axis (not world z axis)
	lea ecx,[ebp+8]
	lea edx,[ebp-16]
	call ToLocalQuat_AxisZ

	lea eax,[ebx+3Ch]		    ;instance quat
	lea ecx,[ebp-16]		    ;local rotation
	lea edx,[ebp-48+0Ch]		    ;new quat
	call QuaternionMul

;move object position in new facing direction (to finally emulate rotation around new point)
	lea eax,[ebp-60]
	push Temp_Fly_Buffer3			;(default/no importance here)
	lea ecx,[ebp-48+0Ch]			;source values (new quat)
	push eax				;param 1 = dest for values (returned in eax)
	call DWORD [CONVERT_TO_FACING_PROC]	;2 params

	lea ecx,[ebp-48+00h]
	push [ATXDRV_CURRENT.RotPosOffset]	;vector length (offset)
	mov edx,ecx
	call FacingToVectorSub			;eax = facing values

;update object position/orientation
	mov eax,[ebx+4Ch]
	mov [ebp-48+1Ch],eax		    ;extra member - don't know if important, staying on safe side

	push 0
	lea edx,[ebp-48+00h]
	mov eax,[ebx]
	push edx
	mov ecx,ebx
	call DWORD [eax+38h]

pop ebx
mov esp,ebp
pop ebp
ret 4

;========================================================
ATXDRV_GOUP_PROC:
;========================================================
;ret

;========================================================
ATXDRV_GODOWN_PROC:
;========================================================
;ret
